unofficial mirror of guix-devel@gnu.org 
 help / color / mirror / code / Atom feed
* guix refresh to a specific version?
@ 2022-06-15 11:34 Hartmut Goebel
  2022-06-17 15:37 ` Ludovic Courtès
  2022-06-28 10:59 ` Maxime Devos
  0 siblings, 2 replies; 7+ messages in thread
From: Hartmut Goebel @ 2022-06-15 11:34 UTC (permalink / raw)
  To: guix-devel

Hi,

I wonder whether this is a way to refresh to a specific version, like 
one can import a specific version:

works:

     guix import pypi trytond@6.2.0

does not work:

     guix refresh -u trytond@6.2.0
     […]
     guix refresh: error: trytond: package not found for version 6.2.0

My use-case is to update 170 trytond modules from 6.0.x to the 6.2.x, 
while 6.4 is current. (I have a list of exact versions, thus being able 
to specify a discrete version is fine.)

-- 
Regards
Hartmut Goebel

| Hartmut Goebel          | h.goebel@crazy-compilers.com               |
| www.crazy-compilers.com | compilers which you thought are impossible |



^ permalink raw reply	[flat|nested] 7+ messages in thread

* Re: guix refresh to a specific version?
  2022-06-15 11:34 guix refresh to a specific version? Hartmut Goebel
@ 2022-06-17 15:37 ` Ludovic Courtès
  2022-06-19  9:23   ` Hartmut Goebel
  2022-06-28 10:59 ` Maxime Devos
  1 sibling, 1 reply; 7+ messages in thread
From: Ludovic Courtès @ 2022-06-17 15:37 UTC (permalink / raw)
  To: Hartmut Goebel; +Cc: guix-devel

Hi,

Hartmut Goebel <h.goebel@crazy-compilers.com> skribis:

> I wonder whether this is a way to refresh to a specific version, like
> one can import a specific version:
>
> works:
>
>     guix import pypi trytond@6.2.0

It’s currently not possible, but pretty much all the machinery is there,
in importers.  It’s a low-hanging fruit that I think we should pick!

Ludo’.


^ permalink raw reply	[flat|nested] 7+ messages in thread

* Re: guix refresh to a specific version?
  2022-06-17 15:37 ` Ludovic Courtès
@ 2022-06-19  9:23   ` Hartmut Goebel
  2022-06-22 13:35     ` Ludovic Courtès
  0 siblings, 1 reply; 7+ messages in thread
From: Hartmut Goebel @ 2022-06-19  9:23 UTC (permalink / raw)
  To: Ludovic Courtès; +Cc: guix-devel

Hi,

Am 17.06.22 um 17:37 schrieb Ludovic Courtès:
> It’s currently not possible, but pretty much all the machinery is there,
> in importers.  It’s a low-hanging fruit that I think we should pick!

I gave it a try and discovered that we need to discuss the interface and 
design:

One can already specify a version, which defines the package to be 
updated. The respective place the code has the comment

Take either the specified version or the latest one.

and this was added by you (Ludo) in 
4b9b3cbbc45afa3e374889847d4ab8673b8b2db2 (April 2015):

refresh: Allow users to refer to specific package versions.

* guix/scripts/refresh.scm (guix-refresh): Use 'specification->package'
   instead of 'find-packages-by-name'.  This allows users to specify
   things like "qt-4.8.6".


Beside this, I'm unconfident about the implementation: Currently refresh 
passes around package objects and passes this to the updater. When 
updating to a specific version, we need to pass around both the package 
and the desired version, which implies case-handling at many places. Any 
idea how to solve this elegantly?

-- 
Regards
Hartmut Goebel

| Hartmut Goebel          | h.goebel@crazy-compilers.com               |
| www.crazy-compilers.com | compilers which you thought are impossible |



^ permalink raw reply	[flat|nested] 7+ messages in thread

* Re: guix refresh to a specific version?
  2022-06-19  9:23   ` Hartmut Goebel
@ 2022-06-22 13:35     ` Ludovic Courtès
  2022-06-28  8:08       ` Hartmut Goebel
  0 siblings, 1 reply; 7+ messages in thread
From: Ludovic Courtès @ 2022-06-22 13:35 UTC (permalink / raw)
  To: Hartmut Goebel; +Cc: guix-devel

Hi,

Hartmut Goebel <h.goebel@crazy-compilers.com> skribis:

> One can already specify a version, which defines the package to be
> updated. The respective place the code has the comment
>
> Take either the specified version or the latest one.
>
> and this was added by you (Ludo) in
> 4b9b3cbbc45afa3e374889847d4ab8673b8b2db2 (April 2015):
>
> refresh: Allow users to refer to specific package versions.
>
> * guix/scripts/refresh.scm (guix-refresh): Use 'specification->package'
>   instead of 'find-packages-by-name'.  This allows users to specify
>   things like "qt-4.8.6".

Like you write, this commit is the “wrong end”: it’s about selecting the
package you’re willing to update.

Most entry points in (guix import …) already take a #:version parameter,
which allows you to ask for a specific version when running ‘guix
import’, as in:

  guix import pypi itsdangerous@1.1.0

The goal here is to expose that in the <upstream-updater> API and to use
it in ‘guix refresh’.

Ludo’.


^ permalink raw reply	[flat|nested] 7+ messages in thread

* Re: guix refresh to a specific version?
  2022-06-22 13:35     ` Ludovic Courtès
@ 2022-06-28  8:08       ` Hartmut Goebel
  2022-06-30 11:58         ` Ludovic Courtès
  0 siblings, 1 reply; 7+ messages in thread
From: Hartmut Goebel @ 2022-06-28  8:08 UTC (permalink / raw)
  To: Ludovic Courtès; +Cc: guix-devel

FYI: I'm working on this. Given the number of importers and updaters is 
just takes some time.

-- 
Regards
Hartmut Goebel

| Hartmut Goebel          | h.goebel@crazy-compilers.com               |
| www.crazy-compilers.com | compilers which you thought are impossible |



^ permalink raw reply	[flat|nested] 7+ messages in thread

* Re: guix refresh to a specific version?
  2022-06-15 11:34 guix refresh to a specific version? Hartmut Goebel
  2022-06-17 15:37 ` Ludovic Courtès
@ 2022-06-28 10:59 ` Maxime Devos
  1 sibling, 0 replies; 7+ messages in thread
From: Maxime Devos @ 2022-06-28 10:59 UTC (permalink / raw)
  To: Hartmut Goebel, guix-devel

[-- Attachment #1: Type: text/plain, Size: 312 bytes --]

Hartmut Goebel schreef op wo 15-06-2022 om 13:34 [+0200]:
> Hi,
> 
> I wonder whether this is a way to refresh to a specific version, like 
> one can import a specific version:
> 
> works:
> 
>      guix import pypi trytond@6.2.0

FWIW, this works for the 'crate' importer.

Greetings,
Maxime.

[-- Attachment #2: This is a digitally signed message part --]
[-- Type: application/pgp-signature, Size: 260 bytes --]

^ permalink raw reply	[flat|nested] 7+ messages in thread

* Re: guix refresh to a specific version?
  2022-06-28  8:08       ` Hartmut Goebel
@ 2022-06-30 11:58         ` Ludovic Courtès
  0 siblings, 0 replies; 7+ messages in thread
From: Ludovic Courtès @ 2022-06-30 11:58 UTC (permalink / raw)
  To: Hartmut Goebel; +Cc: guix-devel

Hartmut Goebel <h.goebel@crazy-compilers.com> skribis:

> FYI: I'm working on this. Given the number of importers and updaters
> is just takes some time.

Excellent.  If you want, you can ping me for early comments on the
<updater> API for this.

Ludo’.


^ permalink raw reply	[flat|nested] 7+ messages in thread

end of thread, other threads:[~2022-06-30 12:01 UTC | newest]

Thread overview: 7+ messages (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2022-06-15 11:34 guix refresh to a specific version? Hartmut Goebel
2022-06-17 15:37 ` Ludovic Courtès
2022-06-19  9:23   ` Hartmut Goebel
2022-06-22 13:35     ` Ludovic Courtès
2022-06-28  8:08       ` Hartmut Goebel
2022-06-30 11:58         ` Ludovic Courtès
2022-06-28 10:59 ` Maxime Devos

Code repositories for project(s) associated with this inbox:

	https://git.savannah.gnu.org/cgit/guix.git

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).